package com.fp.persistence.pviaticos.solicitud;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import javax.persistence.GeneratedValue;

import java.io.Serializable;
import java.math.BigDecimal;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;

import javax.persistence.Version;

import java.lang.reflect.Field;

import javax.persistence.Transient;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

import java.sql.Date;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla VIA_SOL_LIQUIDACION*/
@Entity(name="ViaSolicitudLiquidacion")
@Table(name="VIA_SOL_LIQUIDACION")
public class ViaSolicitudLiquidacion extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad ViaSolicitudLiquidacion
*/
@EmbeddedId
@GenericGenerator(name = "seq_id", strategy = "com.fp.general.keygen.SubSequenceKey", parameters = {
        @Parameter(name = "sql", value = "select coalesce(max(COD_SECUENCIA),0)+1 from VIA_SOL_LIQUIDACION "
                + "where COD_SOLICITUD=:cod_solicitud "), @Parameter(name = "type", value = "java.lang.Integer"),
        @Parameter(name = "param", value = "cod_solicitud,pk.cod_solicitud"), @Parameter(name = "field", value = "cod_secuencia") })
@GeneratedValue(generator = "seq_id")
private ViaSolicitudLiquidacionKey pk;
@Column(name="FEC_FACTURA", nullable=true)

/**
* Campo para el ingreso de la fecha de emision de la factura
*/
private Date fec_factura;

@Column(name="NUM_COMPROBANTE", nullable=true)

/**
* Campo para el ingreso del comprobante de pago
*/
private String num_comprobante;

@Column(name="NOM_EMPRESA", nullable=true)

/**
* Campo para el ingreso del nombre de la empresa de servicio
*/
private String nom_empresa;

@Column(name="NUM_RUC", nullable=true)

/**
* Campo para el ingreso del RUC
*/
private String num_ruc;

@Column(name="COD_GASTO", nullable=true)

/**
* Campo para el ingreso del tipo de gasto empleado en la comision
*/
private String cod_gasto;

@Column(name="VAL_IMPORTE", nullable=true)

/**
* Campo para el ingreso del total de la factura
*/
private BigDecimal val_importe;

@Column(name="NOM_LUGAREMISION", nullable=true)

/**
* Campo para el ingreso del lugar y fecha de emision de la liquidacion
*/
private String nom_lugaremision;

/**Contructor por defecto*/
public ViaSolicitudLiquidacion(){
}
/**Contructor de ViaSolicitudLiquidacion
@param pPk Clave Primaria del entity
*/
public ViaSolicitudLiquidacion(ViaSolicitudLiquidacionKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return ViaSolicitudLiquidacion
*/
public static ViaSolicitudLiquidacion find(EntityManager pEntityManager,ViaSolicitudLiquidacionKey pKey) throws Exception{
    ViaSolicitudLiquidacion obj = pEntityManager.find(ViaSolicitudLiquidacion.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de ViaSolicitudLiquidacion
@return El objeto que referencia a la Clave primaria de ViaSolicitudLiquidacion
*/
public ViaSolicitudLiquidacionKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de ViaSolicitudLiquidacion
@param pPk El objeto que referencia a la nueva Clave primaria de ViaSolicitudLiquidacion
*/
public void setPk(ViaSolicitudLiquidacionKey pPk){
  pk=pPk;
}
/**Obtiene el valor de fec_factura
@return valor de fec_factura*/
public Date getFec_factura(){
  return fec_factura;
}
/**Fija el valor de fec_factura
@param pFec_factura nuevo Valor de fec_factura*/
public void setFec_factura(Date pFec_factura){
  fec_factura=pFec_factura;
}

/**Obtiene el valor de num_comprobante
@return valor de num_comprobante*/
public String getNum_comprobante(){
  return num_comprobante;
}
/**Fija el valor de num_comprobante
@param pNum_comprobante nuevo Valor de num_comprobante*/
public void setNum_comprobante(String pNum_comprobante){
  num_comprobante=pNum_comprobante;
}

/**Obtiene el valor de nom_empresa
@return valor de nom_empresa*/
public String getNom_empresa(){
  return nom_empresa;
}
/**Fija el valor de nom_empresa
@param pNom_empresa nuevo Valor de nom_empresa*/
public void setNom_empresa(String pNom_empresa){
  nom_empresa=pNom_empresa;
}

/**Obtiene el valor de num_ruc
@return valor de num_ruc*/
public String getNum_ruc(){
  return num_ruc;
}
/**Fija el valor de num_ruc
@param pNum_ruc nuevo Valor de num_ruc*/
public void setNum_ruc(String pNum_ruc){
  num_ruc=pNum_ruc;
}

/**Obtiene el valor de cod_gasto
@return valor de cod_gasto*/
public String getCod_gasto(){
  return cod_gasto;
}
/**Fija el valor de cod_gasto
@param pCod_gasto nuevo Valor de cod_gasto*/
public void setCod_gasto(String pCod_gasto){
  cod_gasto=pCod_gasto;
}

/**Obtiene el valor de val_importe
@return valor de val_importe*/
public BigDecimal getVal_importe(){
  return val_importe;
}
/**Fija el valor de val_importe
@param pVal_importe nuevo Valor de val_importe*/
public void setVal_importe(BigDecimal pVal_importe){
  val_importe=pVal_importe;
}

/**Obtiene el valor de nom_lugaremision
@return valor de nom_lugaremision*/
public String getNom_lugaremision(){
  return nom_lugaremision;
}
/**Fija el valor de nom_lugaremision
@param pNom_lugaremision nuevo Valor de nom_lugaremision*/
public void setNom_lugaremision(String pNom_lugaremision){
  nom_lugaremision=pNom_lugaremision;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof ViaSolicitudLiquidacion))return false;
    ViaSolicitudLiquidacion that = (ViaSolicitudLiquidacion) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad ViaSolicitudLiquidacion
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco ViaSolicitudLiquidacion
*/
public Object createInstance(){
 ViaSolicitudLiquidacion instance=new ViaSolicitudLiquidacion();	
 instance.setPk(new ViaSolicitudLiquidacionKey());
 return instance;
}
/**Clona la entidad ViaSolicitudLiquidacion
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  ViaSolicitudLiquidacion p=(ViaSolicitudLiquidacion)this.clone();
  p.setPk((ViaSolicitudLiquidacionKey)this.pk.cloneMe());
  return p;
}
}
